var express    = require('express');
var bodyParser = require('body-parser');

var exec       = require('child_process').exec;
var execSync   = require('child_process').execSync;
var fs         = require('fs');
var path       = require('path');
var fsReaddir = require('fs-readdir');
var Zip        = require('node-zip');
var JSZip = require('jszip');

var exphbs = require('express-handlebars');

//initializer
var nanit = require('nanit');
//load names of available download files
var downloadFiles = require('./downloadFiles.json');
var downloadNames = Object.keys(downloadFiles);

var app = express();

app.use(bodyParser.urlencoded({
  extended: true
}));
app.use(bodyParser.json());

//set handlebars as view engine
app.engine('.hbs', exphbs({extname: '.hbs'}));
app.set('view engine', '.hbs');

//initialize the git repos
//TODO error handling is not working properly, error returned is not in var error, but in req + req and res are undefined!
// nanit.initialize(downloadFiles, function(req,res,err){
// // console.log('err in nanit.initialize:', err);
// // console.log('req in nanit.initialize:', req);
// // console.log('res in nanit.initialize:', res);

// var response = 
//           'There was an error during cloning the git repositories. ' +
//           'Please contact "explorviz-developers-request@listserv.dfn.de" ' +
//           'and add the following information: ' + req;
// 	if(err){
// 		console.log('nanit.initialize error');
// 		res.send(response);
// 		return;
// 	};

// });

//routes
app.get('/', function(req, res){
res.render('home', {downloadFiles: downloadNames});
});


app.post('/', function(req, res, next){
const checkedFiles = Object.keys(req.body);

if(typeof checkedFiles !== 'undefined' && checkedFiles.length > 0){
  res.render('download', {checkedFiles: checkedFiles});
}
  else {
    res.render('home', {downloadFiles: downloadNames});
  }
});


app.get('/download', function(req, res){

const checkedFiles = req.query.checkedFiles.split(',');

var zip = new JSZip();
// create a file to stream archive data to. 
zip.file("README.txt", "text for README");

var frontendFinished = false;
var backendFinished = false;

//----------------------------------------------------------------backend
backendChecked = checkedFiles.find(function(file){
return file === 'explorviz-ui-backend';
});

if (backendChecked){

 const fileName = backendChecked;
 const downloadURL = downloadFiles[backendChecked]; 

 exec('git pull ' + ' && cd ' + fileName + ' && mvn compile war:war ', (error, stdout, stderr) => {

 addBackend();
   
    var response = 
          'There was an error during your build. ' +
          'Please contact "explorviz-developers-request@listserv.dfn.de" ' +
          'and add the following information: ' + error;

    if (error) {
      res.send(response);
      return;
    }

    console.log(stdout);
    console.log(stderr);
}); //.then(addBackend()), würde auch gehen (npm packet: exec-then), aber hilft nicht dabei, zu wissen, wann zip gebaut werden darf


} 
//--------------------------------------------------------------------------------frontend

frontendChecked = checkedFiles.find(function(file){
return file === 'explorviz-ui-frontend';
});

if (frontendChecked){
 const fileName = frontendChecked;
 const downloadURL = downloadFiles[frontendChecked]; 

exec('git pull ', (error, stdout, stderr) => {
installAddons();
  var response = 
          'There was an error during your build. ' +
          'Please contact "explorviz-developers-request@listserv.dfn.de" ' +
          'and add the following information: ' + error;

    if (error) {
      res.send(response);
      return;
    }

});

};

function installAddons(){

checkedPlugins = checkedFiles.filter(function(file){
  return /\bexplorviz-frontend-plugin-\w*/.exec(file);
});

 checkedPlugins.forEach((pluginName) => {
  exec('cd ' + 'explorviz-ui-frontend ' + 'ember install ' + downloadFiles[pluginName], (error, stdout, stderr) => {
 
  var response = 
          'There was an error during your build. ' +
          'Please contact "explorviz-developers-request@listserv.dfn.de" ' +
          'and add the following information: ' + error;

    if (error) {
      res.send(response);
      return;
    }

console.log(stdout);
console.log(stderr);

  });

});
 buildFrontend();
};


function buildFrontend(){
	console.log('buildFrontend()');
//build everything you have
exec('cd explorviz-ui-frontend && ember build --environment=production', (error, stdout, stderr) => {
//exec('cd explorviz-ui-frontend', (error, stdout, stderr) => {

addFrontend(); 


  var response = 
          'There was an error during your build. ' +
          'Please contact "explorviz-developers-request@listserv.dfn.de" ' +
          'and add the following information: ' + error;

    if (error) {
      res.send(response);
      return;
    }

console.log(stdout);
console.log(stderr);


 });
 }; // ------------------------------------------ember build


function addBackend(){
// read a file as a stream and add it to a zip
console.log('addBackend()');
const backendStream = fs.createReadStream("explorviz-ui-backend/target/explorviz-ui-backend-1.0-SNAPSHOT.war");
zip.file("backend.war", backendStream);
backendFinished = true;
createZip();
};

function addFrontend(){
	console.log("in addFrontend");

var stream = fsReaddir('./explorviz-ui-frontend/dist/')
.on('error', function(err) {
  console.log('error:', err);
}).on('data', function(data){
	
	for (var i=0; i<data.length; i++) {
		const frontendStream = fs.createReadStream(data[i]);
		zip.file(data[i], frontendStream);
}

}).on('finish',function(){
	frontendFinished = true;
	createZip();
});
};



function createZip(){
	console.log('frontendFinished', frontendFinished);
	console.log('backendFinished', backendFinished);
	//if(frontendFinished){
		// if (frontendChecked){
		// 	if (backendChecked){
		// 		if(frontendFinished && backendFinished){
		// 			console.log('both');
//create zip and download it
    zip.generateNodeStream({type:'nodebuffer',streamFiles:true}).pipe(fs.createWriteStream('explorviz-builds.zip')).on('finish', function () {
    // JSZip generates a readable stream with a "end" event,
    // but is piped here in a writable stream which emits a "finish" event.
    console.log("explorviz-builds.zip written.");
    res.download('explorviz-builds.zip');
}); 
//} 

};
// } else if (frontendFinished) {//!backendChecked
// 	console.log('frontend only');
// zip.generateNodeStream({type:'nodebuffer',streamFiles:true}).pipe(fs.createWriteStream('explorviz-builds.zip')).on('finish', function () {
//     // JSZip generates a readable stream with a "end" event,
//     // but is piped here in a writable stream which emits a "finish" event.
//     console.log("explorviz-builds.zip frontend only written.");
//     res.download('explorviz-builds.zip');
// });}
    

// } else if (backendChecked){//!frontendChecked
// 	if (backendFinished){
// 		console.log('backend only');
// 		//create zip and download it
//     zip.generateNodeStream({type:'nodebuffer',streamFiles:true}).pipe(fs.createWriteStream('explorviz-builds.zip')).on('finish', function () {
//     // JSZip generates a readable stream with a "end" event,
//     // but is piped here in a writable stream which emits a "finish" event.
//     console.log("explorviz-builds.zip backend only written.");
//     res.download('explorviz-builds.zip');
// });
// 	}
// }
// }
});


app.listen(8080);
console.log("Downloader started on port 8080.");